                                            %Amsha Nahid
%PhD project
%3D heat transfer model for a unsalted box with nucleation rate term.
%l=space level in x direction
%m= space level in y direction
%n= space level in z direction
%i= time level
clock
tic
Lx=0.385-(2*(4.15e-3+0.085e-3));                   %length of unsalted box in x direction(length)
Ly=0.280-(4* 4.15e-3+3*0.085e-3);                  %length of unsalted box in y direction(height)
Lz=0.250-(2*(4.15e-3+0.085e-3));          %length of unsalted box in z direction(width)
Dt=200;                     %time step
L =10;                      %number of cells in x direction
M =10;                      % no. of cells in y direction
N =10;                      %number of cells in Z dirction.
Dx=Lx/L;                    %step in x-direction
Dy=Ly/M;                    %step in y-direction
Dz=Lz/N;                    %step in z-direction
                
Ti = 2;   %initial temperature of the block.
dHif=(57.3384)*1000;
Hif=1.154880e+005;
Cu=3.08*1000;            % specific heat of water
Fi=10^-10;               %initial Fraction Frozen
%latent heat L is defined as as a function 'La'
%Nucleation Rate J is defined as a function file  'J'   
%Thermal conductivity  is defined as a function file  'K' 
%densityis defined as a function file  'roh' 
Ci=roh*Cu;                 %volumetric specificheat capacity        
v=1.1093E-17;              % volume of droplet
Tif=-5.35;     % initial freezing point
tfinal=200*3600;            %number of time steps 
tprint=3600;                %output time 
telapes=0;                  %time elapse
b=1;
h=[4.2,4.2,3.3,3.3,4.2,4.2];           %heat transfer co-efficient on six surfaces.[X=0 X=Lx Y=0 Y=My Z=0 Z=Nz]
Ta =ones(6,1); %ambinent temperature on six faces[X=0 X=Lx Y=0 Y=My Z=0 Z=Nz]
Q=zeros(L+1,M+1,N+1);       %Heat generation term
 %initial conditions
T=Ti*ones(L+1,M+1,N+1,1);   %temperature
F=Fi*ones(L+1,M+1,N+1,1);   %fraction forzen
C=Ci*ones(L+1,M+1,N+1,1);   %volumetric specificheat capacity 
A=ones(L+1,M+1,N+1,1);      %term to calculate Tm (see chapter 6 for details)
B=ones(L+1,M+1,N+1,1);      %term to calculate Tm (see chapter 6 for details)
Tstore(:,:,:,b)= T(:,:,:,1);%stroring the outout temperature
Fstore(:,:,:,b)=F(:,:,:,1);%stroring the outout fraction frozen
R=ones(L+1,M+1,N+1,1);%Term to calculate Tm
t(b)=0;
i=1;
s=4;%Avrami index 
g=1;
v=v^(1/s);%droplet volume
u=0.014;%crystalization constant
time=0;
a=1000*58.2761; %enthalpy constant refer to a' in chapter 6
w=1000*1.6782;%enthalpy constant refer to b' in chapter 6
c=-354.1187*1000;%enthalpy constant refer to c' in chapter 6
while time < tfinal % calculation loop
time=time+Dt;
telapes=telapes+Dt;
      if (time<=15*3600)%(time<=15*3600);
   Ta=(-0.1338*(time/3600)-16.034)*ones(6,1);% Ta=(0.028*(time/3600)^2-0.5665*(time/3600)-13.701)*ones(6,1);%
    else if (time>15*3600) & (time<=19*3600);
           Ta=(1.45*(time/3600)-39.75)*ones(6,1);
        else if (time>19*3600) & (time<=23*3600);
            Ta=(-1.25*(time/3600) + 11.55)*ones(6,1);
 
            else if(time>23*3600) & (time<=58.84*3600);
            Ta=(-0.0267*(time/3600)-16.429)*ones(6,1);%Ta=(-0.0157*(time/3600)-16.464)*ones(6,1);%
                else 
                    Ta=-18*ones(6,1);
                end
                end
end
     end  
   %internal nodes calculations
for p=2:L
    for m=2:M
       for n=2:N
            if T(p,m,n,i)>Tif;
            Cf=0;
       Cu=3.08*1000;
  
            end
            if T(p,m,n,i)<=Tif
             Cf=1.6782*1000;
         Cu=3.08*1000;
    end
      
          if T(p,m,n,i)>Tif 
              F(p,m,n,i+1)=10e-10;
          end
          if T(p,m,n,i)<=Tif
              A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
             Tm =(-B+ sqrt(B^2+4*A*c))/(2*A);
             if Tm<=T(p,m,n,i)
                 R(p,m,n,i)=0;
                  F(p,m,n,i+1)=F(p,m,n,i);
             else
               R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
           F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
          end
          end
     
         C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
           T(p,m,n,i+1) = T(p,m,n,i)+Dt/C(p,m,n,i)*( ...
                1/Dx^2*(K(F(p,m,n,i))*(T(p+1,m,n,i)-T(p,m,n,i)) ...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))) ...
                +1/Dy^2*(K(F(p,m,n,i))*(T(p,m+1,n,i)-T(p,m,n,i)) ...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))) ...
                +1/Dz^2*(K(F(p,m,n,i))*(T(p,m,n+1,i)-T(p,m,n,i)) ...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n-1,i))) ...
                +Q(p,m,n)...
                +roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s)); 
   
       end
   end
end

%calculations for 12 edges.
 %(1)---4 edges making the roof of the block.
 %front
 for p=2:L
     for m=M+1
         for n=1
                   
              
                if T(p,m,n,i)>Tif;
       Cf=0;
  Cu=3.08*1000;
        F(p,m,n,i+1)=10e-10;
     else 
       Cf=1.6782*1000;
      Cu=3.08*1000;  ;
       A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                 R(p,m,n,i)=0;
                  F(p,m,n,i+1)=F(p,m,n,i);
             else
       R(p,m,n,i)=u*(Tm -T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                end

                C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
           T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2*h(4)/Dy*(Ta(4)-T(p,m,n,i))...
               -2/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
               +2*h(5)/Dz*(Ta(5)-T(p,m,n,i))...
               -2/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
               +1/Dx^2*(K(F(p,m,n,i))*(T(p-1,m,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i)))...
                +Q(p,n)+roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));  
              
       end
   end
end
%back
 for p=2:L
     for m=M+1
         for n=N+1
                   
               
               if T(p,m,n,i)>Tif;
        Cf=0;
  Cu=3.08*1000;;
        F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
     A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            TTm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
        R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
               end
    
                C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
           T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2*h(4)/Dy*(Ta(4)-T(p,m,n,i))...
               -2/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
               +2*h(6)/Dz*(Ta(6)-T(p,m,n,i))...
               -2/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
               +1/Dx^2*(K(F(p,m,n,i))*(T(p-1,m,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i)))...
               +Q(p,m,n)+roh*La(T(p,m,n,i))...
               *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));
            
         end
   end
end
%right
 for p=L+1
     for m=M+1
         for n=2:N 
                
                    if T(p,m,n,i)>Tif;
      Cf=0;
     Cu=3.08*1000;;
        F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
     A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
        R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                    end
          
   
                    C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
           T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2*h(2)/Dx*(Ta(2)-T(p,m,n,i))...
               -2/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
               +2*h(4)/Dy*(Ta(4)-T(p,m,n,i))...
               -2/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
               +1/Dz^2*(K(F(p,m,n,i))*(T(p,m,n-1,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i)))...
               +Q(p,m,n)+roh*La(T(p,m,n,i))...
               *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));   
            
       end
   end
end
%left
 for p=1
     for m=M+1
         for n=2:N
             if T(p,m,n,i)>Tif;
       Cf=0;
     Cu=3.08*1000;;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
      A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                R(p,m,n,i)=0;
                 F(p,m,n,i+1)=F(p,m,n,i);
             else
       R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
             end
    
   
             C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
           T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2*h(1)/Dx*(Ta(1)-T(p,m,n,i))...
               -2/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
               +2*h(4)/Dy*(Ta(4)-T(p,m,n,i))...
               -2/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
               +1/Dz^2*(K(F(p,m,n,i))*(T(p,m,n-1,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i)))...
              +Q(p,m,n)+roh*La(T(p,m,n,i))...
              *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s)); 
           
       end
   end
end
%(2) edges made the bottom of the rectangle:
%front
 for p=2:L
     for m=1
         for n=1      
                if T(p,m,n,i)>Tif;
        Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
       A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
       R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                end
          
   
               C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
             T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2*h(3)/Dy*(Ta(3)-T(p,m,n,i))...
               -2/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
               +2*h(5)/Dz*(Ta(5)-T(p,m,n,i))...
               -2/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
               +1/Dx^2*(K(F(p,m,n,i))*(T(p-1,m,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i)))...
                 +Q(p,m,n)+roh*La(T(p,m,n,i))...
                 *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));  
       end
   end
end
%back
 for p=2:L
     for m=1
         for n=N+1             
 
                if T(p,m,n,i)>Tif;
        Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
     A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
         R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                end
          
   
                C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
            
           T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2*h(3)/Dy*(Ta(3)-T(p,m,n,i))...
               -2/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
               +2*h(6)/Dz*(Ta(6)-T(p,m,n,i))...
               -2/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
               +1/Dx^2*(K(F(p,m,n,i))*(T(p-1,m,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i)))...
                +Q(p,m,n)+roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));   
       end
   end
 end

%right
for p=L+1
     for m=1
         for n=2:N   
                  
                if T(p,m,n,i)>Tif;
        Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
    A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
        R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
       
            end
                end
          
   
                   C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
           T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2*h(2)/Dx*(Ta(2)-T(p,m,n,i))...
               -2/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
               +2*h(3)/Dy*(Ta(3)-T(p,m,n,i))...
               -2/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
               +1/Dz^2*(K(F(p,m,n,i))*(T(p,m,n-1,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i)))...
                 +Q(p,m,n)+roh*La(T(p,m,n,i))...
                 *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));
         end
   end
end
%left
for p=1
     for m=1
         for n=2:N   
                  
                if T(p,m,n,i)>Tif;
                Cf=0;
      Cu=3.08*1000;;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
  A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
             Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
              if Tm<T(p,m,n,i)
                 R(p,m,n,i)=0;
                  F(p,m,n,i+1)=F(p,m,n,i);
             else
        R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
             end
                end
          
   
                C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
           T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2*h(1)/Dx*(Ta(1)-T(p,m,n,i))...
               -2/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
               +2*h(3)/Dy*(Ta(3)-T(p,m,n,i))...
               -2/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
               +1/Dz^2*(K(F(p,m,n,i))*(T(p,m,n-1,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i)))...
                 +Q(p,m,n)+roh*La(T(p,m,n,i))...
                 *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s)); ;
       end
   end
end
% (3) (the  two pillars on the right)
%front
for p=L+1
     for m=2:M
         for n=1 
                 
                    if T(p,m,n,i)>Tif;
        Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
     A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
         R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                    end
       
   
                    C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
           T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2*h(2)/Dx*(Ta(2)-T(p,m,n,i))...
               -2/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
               +2*h(5)/Dz*(Ta(5)-T(p,m,n,i))...
               -2/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
               +1/Dy^2*(K(F(p,m,n,i))*(T(p,m-1,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i)))...
               +Q(p,m,n)+roh*La(T(p,m,n,i))...
               *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s)); 
       end
   end
end
%back
for p=L+1
     for m=2:M
         for n=N+1  
          
                if T(p,m,n,i)>Tif;
        Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
    A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
       R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                end
          
   
                C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
           T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2*h(2)/Dx*(Ta(2)-T(p,m,n,i))...
               -2/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
               +2*h(6)/Dz*(Ta(6)-T(p,m,n,i))...
               -2/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
               +1/Dy^2*(K(F(p,m-1,n,i))*(T(p,m-1,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i)))...
               +Q(p,m,n)+roh*La(T(p,m,n,i))...
               *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));  
        
       end
   end
end
% two pillars on left
%front
for p=1
     for m=2:M
         for n=1
              
                if T(p,m,n,i)>Tif;
        Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
  A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
        R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                end
          
   
                   C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
           T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2*h(1)/Dx*(Ta(1)-T(p,m,n,i))...
               -2/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
               +2*h(5)/Dz*(Ta(5)-T(p,m,n,i))...
               -2/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
               +1/Dy^2*(K(F(p,m-1,n,i))*(T(p,m-1,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i)))...
               +Q(p,m,n)+roh*La(T(p,m,n,i))...
               *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s)); 
             
       end
   end
end
%back
for p=1
     for m=2:M
         for n=N+1 
                if T(p,m,n,i)>Tif;
        Cf=0;
      Cu=3.08*1000;;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
     A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
        R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                end
          
   
                C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
           T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2*h(1)/Dx*(Ta(1)-T(p,m,n,i))...
               -2/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
               +2*h(6)/Dz*(Ta(6)-T(p,m,n,i))...
               -2/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
               +1/Dy^2*(K(F(p,m,n,i))*(T(p,m-1,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i)))...
               +Q(p,m,n)+roh*La(T(p,m,n,i))...
               *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));  
             
       end
   end
end
% 8 corners
%(1)
for p=1
    for m=M+1
        for n=1
                if T(p,m,n,i)>Tif;
    Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
  A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
       R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                end
          
   
                C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
            T(p,m,n,i+1) = T(p,m,n,i)+2*Dt/C(p,m,n,i)*(...
                1/Dx*h(1)*(Ta(1)-T(p,m,n,i))...
                -1/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
                +1/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                -1/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
                +1/Dz*h(5)*(Ta(5)-T(p,m,n,i))...
                -1/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
                +Q(p,m,n)/2+roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));   
             
        end
    end
end
%(2)
for p=L+1
    for m=M+1
        for n=1
                if T(p,m,n,i)>Tif;
        Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ; 
      A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
       R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                end
          
   
                C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
            T(p,m,n,i+1) = T(p,m,n,i)+2*Dt/C(p,m,n,i)*(...
                1/Dx*h(2)*(Ta(2)-T(p,m,n,i))...
                -1/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
                +1/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                -1/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
                +1/Dz*h(5)*(Ta(5)-T(p,m,n,i))...
                -1/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
                +Q(p,m,n)/2+roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));   
         
        end
    end
end
%(3)
for p=L+1
    for m=1
        for n=1
                if T(p,m,n,i)>Tif;
        Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
 A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
         R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                end
          
   
                C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
            T(p,m,n,i+1) = T(p,m,n,i)+2*Dt/C(p,m,n,i)*(...
                1/Dx*h(2)*(Ta(2)-T(p,m,n,i))...
                -1/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
                +1/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                -1/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
                +1/Dz*h(5)*(Ta(5)-T(p,m,n,i))...
                -1/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
                +Q(p,m,n)/2+roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s)); 
        
        end
    end
end
%(4)
for p=1
    for m=1
        for n=1
      
                if T(p,m,n,i)>Tif;
       Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
     A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
        R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                end
          
   
                C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
            T(p,m,n,i+1) = T(p,m,n,i)+2*Dt/C(p,m,n,i)*(...
                1/Dx*h(1)*(Ta(1)-T(p,m,n,i))...
                -1/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
                +1/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                -1/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
                +1/Dz*h(5)*(Ta(5)-T(p,m,n,i))...
                -1/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
                +Q(p,m,n)/2+roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s)); 
     
        end
    end
end
%(5)
for p=1
    for m=M+1
        for n=N+1
             
                   if T(p,m,n,i)>Tif;
      Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
     A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
       
       R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                   end
          
   
                   C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
            T(p,m,n,i+1) = T(p,m,n,i)+2*Dt/C(p,m,n,i)*(...
                1/Dx*h(1)*(Ta(1)-T(p,m,n,i))...
                -1/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
                +1/Dy*h(4)*(Ta(4)-T(p,m,n,i))...
                -1/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
                +1/Dz*h(6)*(Ta(6)-T(p,m,n,i))...
                -1/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
                +Q(p,m,n)/2+roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));
           
        end
    end
end
%(6)
for p=L+1
    for m=M+1
        for n=N+1
                        if T(p,m,n,i)>Tif;
      Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
 A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
       R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                        end
          
   
                        C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
            T(p,m,n,i+1) = T(p,m,n,i)+2*Dt/C(p,m,n,i)*(...
                1/Dx*h(2)*(Ta(2)-T(p,m,n,i))...
                -1/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
                +1/Dy*h(4)*(Ta(4)-T(p,m,n,i))...
                -1/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
                +1/Dz*h(6)*(Ta(6)-T(p,m,n,i))...
                -1/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
                +Q(p,m,n)/2+roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s)); 
         
        end
    end
end
%(7)
for p=L+1
    for m=1
        for n=N+1
                if T(p,m,n,i)>Tif;
      Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
 A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
       R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
               end
          
   
                C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
            T(p,m,n,i+1) = T(p,m,n,i)+2*Dt/C(p,m,n,i)*(...
                1/Dx*h(2)*(Ta(2)-T(p,m,n,i))...
                -1/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
                +1/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                -1/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
                +1/Dz*h(6)*(Ta(6)-T(p,m,n,i))...
                -1/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
                +Q(p,m,n)/2+roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s)); 
   
        end
    end
end
%(8)
for p=1
    for m=1
        for n=N+1
             if T(p,m,n,i)>Tif;
      Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
       A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
        R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
             end
          
   
             C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
            T(p,m,n,i+1) = T(p,m,n,i)+2*Dt/C(p,m,n,i)*(...
                1/Dx*h(1)*(Ta(1)-T(p,m,n,i))...
                -1/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
                +1/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                -1/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
                +1/Dz*h(6)*(Ta(6)-T(p,m,n,i))...
                -1/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
                +Q(p,m,n)/2+roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));
              
        end
    end
end
%calculation of nodes on 6 faces
%for face X=0 (left)
for p=1
    for m=2:M
       for n=2:N
                 if T(p,m,n,i)>Tif;
       Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
       A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
       R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
                 end
end
                         
   
          C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
           T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
               2/Dx*h(1)*(Ta(1)-T(p,m,n,i))...
               -2/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
               +1/Dy^2*(K(F(p,m,n,i))*(T(p,m+1,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i)))...
               +1/Dz^2*(K(F(p,m,n,i))*(T(p,m,n-1,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i)))...
               +Q(p,m,n)+roh*La(T(p,m,n,i))...
               *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s)); 
            
        end
    end
 end
%for face X=Lx(right)
for p=L+1
    for m=2:M
        for n=2:N
                    if T(p,m,n,i)>Tif;
       Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
      A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
       R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
                    end
                     end
          
   
                    C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
            T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
                2/Dx*h(2)*(Ta(2)-T(p,m,n,i))...
                -2/Dx^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
                +1/Dy^2*(K(F(p,m,n,i))*(T(p,m+1,n,i)-T(p,m,n,i))...
                     -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i)))...
                +1/Dz^2*(K(F(p,m,n,i))*(T(p,m,n-1,i)-T(p,m,n,i))...
                     -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i)))...
                +Q(p,m,n)+roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));  
      
        end
    end
end
%for face Y=0 (bottom)
for p=2:L
    for m=1
        for n=2:N
                    if T(p,m,n,i)>Tif;
      Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
      A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
       
       R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                    end
        
   
                    C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
             T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
                 2/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                 -2/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
                 +1/Dx^2*(K(F(p,m,n,i))*(T(p+1,m,n,i)-T(p,m,n,i))...
                     -K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i)))...
                 +1/Dz^2*(K(F(p,m,n,i))*(T(p,m,n+1,i)-T(p,m,n,i))...
                     -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n-1,i)))...
                 +Q(p,m,n)+roh*La(T(p,m,n,i))...
                 *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s)); 
           
        end
    end
end
%for face Y=My (roof)
for p=2:L
    for m=M+1
        for n=2:N
                if T(p,m,n,i)>Tif;
       Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
       A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
       R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                end
          
   
                C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
             T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
                 2/Dy*h(4)*(Ta(4)-T(p,m,n,i))...
                 -2/Dy^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
                 +1/Dx^2*(K(F(p,m,n,i))*(T(p+1,m,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i)))...
                 +1/Dz^2*(K(F(p,m,n,i))*(T(p,m,n+1,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n-1,i)))...
                 +Q(p,m,n)+roh*La(T(p,m,n,i))...
                 *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));
               x(p,m,n,i+1)=roh*La(T(p,m,n,i))...
                *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
                 
        end
    end
end
%for face Z=0 (front)
for p=2:L
    for m=2:M
        for n=1
                   
                 
                 if T(p,m,n,i)>Tif;
       Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
       A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);;
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
         R(p,m,n,i)=u*(Tm-T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
                 end
          
   
                 C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
        
             T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
                 2/Dz*h(5)*(Ta(5)-T(p,m,n,i))...
                 -2/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
                 +1/Dx^2*(K(F(p,m,n,i))*(T(p-1,m,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i)))...
                 +1/Dy^2*(K(F(p,m,n,i))*(T(p,m-1,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m+1,n,i)))...
                 +Q(p,m,n)+roh*La(T(p,m,n,i))...
                 *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));
              
         end
     end
 end
 %for face Z=Nz (back)
 for p=2:L
     for m=2:M
         for n=N+1        
                   
                
       if T(p,m,n,i)>Tif;
      Cf=0;
      Cu=3.08*1000;
       F(p,m,n,i+1)=10e-10;
     else 
         Cf=1.6782*1000;
      Cu=3.08*1000;; ;
    A=F(p,m,n,i)*Cf+(1-F(p,m,n,i))*Cu-w;
              B=-(a-Hif+F(p,m,n,i)*dHif+Tif*(A+w));
            Tm=(-B+ sqrt(B^2+4*A*c))/(2*A);
             if Tm<T(p,m,n,i)
                  R(p,m,n,i)=0;
                   F(p,m,n,i+1)=F(p,m,n,i);
             else
        R(p,m,n,i)=u*(Tm -T(p,m,n,i))^(g*3/s)*s*(J(T(p,m,n,i)))^(1/s)*v*Dt; 
       F(p,m,n,i+1)=F(p,m,n,i)+R(p,m,n,i)*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s);
            end
       end
          
   
                 C(p,m,n,i+1)=roh*(Cu+(Cf-Cu)*F(p,m,n,i+1));
            
             T(p,m,n,i+1)=T(p,m,n,i)+Dt/C(p,m,n,i)*(...
                 2/Dz*h(6)*(Ta(6)-T(p,m,n,i))...
                 -2/Dz^2*K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
                 +1/Dx^2*(K(F(p,m,n,i))*(T(p+1,m,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i)))...
                 +1/Dy^2*(K(F(p,m,n,i))*(T(p,m+1,n,i)-T(p,m,n,i))...
                    -K(F(p,m,n,i))*(T(p,m,n,i)-T(p,m-1,n,i)))...
                 +Q(p,m,n)+roh*La(T(p,m,n,i))...
                 *R(p,m,n,i)/Dt*(1-F(p,m,n,i))*(-log(1-F(p,m,n,i)))^(1-1/s));
           
         end
     end
 end
 if telapes >=tprint
   b=b+1;
   Tstore(:,:,:,b)= T(:,:,:,i+1);
   Fstore(:,:,:,b)=F(:,:,:,i+1);


   t(b)=time;
   telapes =0;
end

T(:,:,:,i)=T(:,:,:,i+1);
F(:,:,:,i)=F(:,:,:,i+1);
C(:,:,:,i)=C(:,:,:,i+1);


time
end
toc
clock
