 %Amsha Nahid
%PhD project
%3D heat transfer model for a rectangular block.
%l=space level in x direction
%m= space level in y direction
%n= space level in z direction
%i= time level
clock
tic
Lx=0.385-(2*(4.15e-3+0.085e-3));                   %length of unsalted box in x direction(length)
Ly=0.280-(4* 4.15e-3+3*0.085e-3);                  %length of unsalted box in y direction(height)
Lz=0.250-(2*(4.15e-3+0.085e-3));                        %length of pallet in z direction(width)
Dt=100;                    %time step
P =10;                      %number of cells in x direction
M =10;                       % no. of cells in y direction
N =10;                        %number of cells in Z dirction.
Dx=Lx/P;                     %step in x-direction
Dy=Ly/M;                     %step in y-direction
Dz=Lz/N;                     %step in z-direction
Ti =2; %initial temperature of the block.
roh=970;
cp=3.08*1000;
C=roh*cp;
Hi=Ti*C;% enthalpy at -18.8*roh%TtoH(Ti);  TtoH(Ti);%          %Enthalpy 
tfinal=200*3600;       %number of time steps 
tprint=3600;
telapes=0;
b=1;
%h=ones(6,1);         %heat transfer co-efficient on six surfaces.[X=0 X=Lx Y=0 Y=My Z=0 Z=Nz]
h=[4.2,4.2,3 .3,3.3,3.3,3.3];
Ta =ones(6,1);       %ambinent temperature on six faces[X=0 X=Lx Y=0 Y=My Z=0 Z=Nz]
Q=zeros(P+1,M+1,N+1);       %Heat generation term
%initial calculation of heat generation term
for p=1:P+1
    for m=1:M+1
        for n=1:N+1
            Q(p,m,n) = 0;
        end 
    end
 end
%initial conditions
T=Ti*ones(P+1,M+1,N+1,1); %temperature
H=Hi*ones(P+1,M+1,N+1,1); %enthalpy
Tstore(:,:,:,b)= T(:,:,:,1);
%Hstore(:,:,:,b)=H(:,:,:,1);
t(b)=0;
i=1;
time=0;
while time < tfinal
 %if time >= 3*Dt
  %  dbstop in butter at 64;
  %end

time=time+Dt;
telapes=telapes+Dt;
     if (time<=15*3600)%(time<=15*3600);
   Ta=(-0.1338*(time/3600)-16.034)*ones(6,1);% Ta=(0.028*(time/3600)^2-0.5665*(time/3600)-13.701)*ones(6,1);%
    else if (time>=15*3600) & (time<=19*3600);
           Ta=(1.45*(time/3600)-39.75)*ones(6,1);
        else if (time>=19*3600) & (time<=23*3600);
            Ta=(-1.25*(time/3600) + 11.55)*ones(6,1);
 
            elseif (time>=23*3600) & (time<=60*3600);
            Ta=(-0.0267*(time/3600)-16.429)*ones(6,1);%Ta=(-0.0157*(time/3600)-16.464)*ones(6,1);%
            else Ta=-18.03*ones(6,1);
            end
        
     end
     end
     

%internal nodes calculations
for p=2:P
    for m=2:M
       for n=2:N
           H(p,m,n,i+1) = H(p,m,n,i)+Dt*( ...
                1/Dx^2*(K(T(p+1,m,n,i),T(p,m,n,i))*(T(p+1,m,n,i)-T(p,m,n,i)) ...
                    -K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))) ...
                +1/Dy^2*(K(T(p,m+1,n,i),T(p,m,n,i))*(T(p,m+1,n,i)-T(p,m,n,i)) ...
                    -K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))) ...
                +1/Dz^2*(K(T(p,m,n+1,i),T(p,m,n,i))*(T(p,m,n+1,i)-T(p,m,n,i)) ...
                    -K(T(p,m,n,i),T(p,m,n-1,i))*(T(p,m,n,i)-T(p,m,n-1,i))) ...
                +Q(p,m,n));
       end
   end
end
%calculations for 12 edges.
 %(1)---4 edges making the roof of the block.
 %front
 for p=2:P
     for m=M+1
         for n=1
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2*h(4)/Dy*(Ta(4)-T(p,m,n,i))...
               -2/Dy^2*K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
               +2*h(5)/Dz*(Ta(5)-T(p,m,n,i))...
               -2/Dz^2*K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
               +1/Dx^2*(K(T(p-1,m,n,i),T(p,m,n,i))*(T(p-1,m,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i)))...
                +Q(p,m,n));
       end
   end
end
%back
 for p=2:P
     for m=M+1
         for n=N+1
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2*h(4)/Dy*(Ta(4)-T(p,m,n,i))...
               -2/Dy^2*K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
               +2*h(6)/Dz*(Ta(6)-T(p,m,n,i))...
               -2/Dz^2*K(T(p,m,n,i),T(p,m,n-1,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
               +1/Dx^2*(K(T(p-1,m,n,i),T(p,m,n,i))*(T(p-1,m,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i)))...
               +Q(p,m,n));
       end
   end
end
%right
 for p=P+1
     for m=M+1
         for n=2:N
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2*h(2)/Dx*(Ta(2)-T(p,m,n,i))...
               -2/Dx^2*K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
               +2*h(4)/Dy*(Ta(4)-T(p,m,n,i))...
               -2/Dy^2*K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
               +1/Dz^2*(K(T(p,m,n-1,i),T(p,m,n,i))*(T(p,m,n-1,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i)))...
               +Q(p,m,n));
       end
   end
end
%left
 for p=1
     for m=M+1
         for n=2:N
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2*h(1)/Dx*(Ta(1)-T(p,m,n,i))...
               -2/Dx^2*K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
               +2*h(4)/Dy*(Ta(4)-T(p,m,n,i))...
               -2/Dy^2*K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
               +1/Dz^2*(K(T(p,m,n-1,i),T(p,m,n,i))*(T(p,m,n-1,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i)))...
               +Q(p,m,n));
       end
   end
end
%(2) edges made the bottom of the rectangle:
%front
 for p=2:P
     for m=1
         for n=1
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2*h(3)/Dy*(Ta(3)-T(p,m,n,i))...
               -2/Dy^2*K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
               +2*h(5)/Dz*(Ta(5)-T(p,m,n,i))...
               -2/Dz^2*K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
               +1/Dx^2*(K(T(p-1,m,n,i),T(p,m,n,i))*(T(p-1,m,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i)))...
               +Q(p,m,n));
       end
   end
end
%back
 for p=2:P
     for m=1
         for n=N+1
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2*h(3)/Dy*(Ta(3)-T(p,m,n,i))...
               -2/Dy^2*K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
               +2*h(6)/Dz*(Ta(6)-T(p,m,n,i))...
               -2/Dz^2*K(T(p,m,n,i),T(p,m,n-1,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
               +1/Dx^2*(K(T(p-1,m,n,i),T(p,m,n,i))*(T(p-1,m,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i)))...
               +Q(p,m,n));
       end
   end
end
%right
for p=P+1
     for m=1
         for n=2:N
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2*h(2)/Dx*(Ta(2)-T(p,m,n,i))...
               -2/Dx^2*K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
               +2*h(3)/Dy*(Ta(3)-T(p,m,n,i))...
               -2/Dy^2*K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
               +1/Dz^2*(K(T(p,m,n-1,i),T(p,m,n,i))*(T(p,m,n-1,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i)))...
               +Q(p,m,n));
       end
   end
end
%left
for p=1
     for m=1
         for n=2:N
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2*h(1)/Dx*(Ta(1)-T(p,m,n,i))...
               -2/Dx^2*K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
               +2*h(3)/Dy*(Ta(3)-T(p,m,n,i))...
               -2/Dy^2*K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
               +1/Dz^2*(K(T(p,m,n-1,i),T(p,m,n,i))*(T(p,m,n-1,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i)))...
               +Q(p,m,n));
       end
   end
end
% (3) (the  two pillars on the right)
%front
for p=P+1
     for m=2:M
         for n=1
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2*h(2)/Dx*(Ta(2)-T(p,m,n,i))...
               -2/Dx^2*K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
               +2*h(5)/Dz*(Ta(5)-T(p,m,n,i))...
               -2/Dz^2*K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
               +1/Dy^2*(K(T(p,m-1,n,i),T(p,m,n,i))*(T(p,m-1,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i)))...
               +Q(p,m,n));
       end
   end
end
%back
for p=P+1
     for m=2:M
         for n=N+1
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2*h(2)/Dx*(Ta(2)-T(p,m,n,i))...
               -2/Dx^2*K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
               +2*h(6)/Dz*(Ta(6)-T(p,m,n,i))...
               -2/Dz^2*K(T(p,m,n,i),T(p,m,n-1,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
               +1/Dy^2*(K(T(p,m-1,n,i),T(p,m,n,i))*(T(p,m-1,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i)))...
               +Q(p,m,n));
       end
   end
end
% two pillars on left
%front
for p=1
     for m=2:M
         for n=1
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2*h(1)/Dx*(Ta(1)-T(p,m,n,i))...
               -2/Dx^2*K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
               +2*h(5)/Dz*(Ta(5)-T(p,m,n,i))...
               -2/Dz^2*K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
               +1/Dy^2*(K(T(p,m-1,n,i),T(p,m,n,i))*(T(p,m-1,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i)))...
               +Q(p,m,n));
       end
   end
end
%back
for p=1
     for m=2:M
         for n=N+1
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2*h(1)/Dx*(Ta(1)-T(p,m,n,i))...
               -2/Dx^2*K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
               +2*h(6)/Dz*(Ta(6)-T(p,m,n,i))...
               -2/Dz^2*K(T(p,m,n,i),T(p,m,n-1,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
               +1/Dy^2*(K(T(p,m-1,n,i),T(p,m,n,i))*(T(p,m-1,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i)))...
               +Q(p,m,n));
       end
   end
end
% 8 corners
%(1)
for p=1
    for m=M+1
        for n=1
            H(p,m,n,i+1) = H(p,m,n,i)+2*Dt*(...
                1/Dx*h(1)*(Ta(1)-T(p,m,n,i))...
                -1/Dx^2*K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
                +1/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                -1/Dy^2*K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
                +1/Dz*h(5)*(Ta(5)-T(p,m,n,i))...
                -1/Dz^2*K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
                +Q(p,m,n)/2);
        end
    end
end
%(2)
for p=P+1
    for m=M+1
        for n=1
            H(p,m,n,i+1) = H(p,m,n,i)+2*Dt*(...
                1/Dx*h(2)*(Ta(2)-T(p,m,n,i))...
                -1/Dx^2*K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
                +1/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                -1/Dy^2*K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
                +1/Dz*h(5)*(Ta(5)-T(p,m,n,i))...
                -1/Dz^2*K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
                +Q(p,m,n)/2);
        end
    end
end
%(3)
for p=P+1
    for m=1
        for n=1
            H(p,m,n,i+1) = H(p,m,n,i)+2*Dt*(...
                1/Dx*h(2)*(Ta(2)-T(p,m,n,i))...
                -1/Dx^2*K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
                +1/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                -1/Dy^2*K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
                +1/Dz*h(5)*(Ta(5)-T(p,m,n,i))...
                -1/Dz^2*K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
                +Q(p,m,n)/2);
        end
    end
end
%(4)
for p=1
    for m=1
        for n=1
            H(p,m,n,i+1) = H(p,m,n,i)+2*Dt*(...
                1/Dx*h(1)*(Ta(1)-T(p,m,n,i))...
                -1/Dx^2*K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
                +1/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                -1/Dy^2*K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
                +1/Dz*h(5)*(Ta(5)-T(p,m,n,i))...
                -1/Dz^2*K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
                +Q(p,m,n)/2);
        end
    end
end
%(5)
for p=1
    for m=M+1
        for n=N+1
            H(p,m,n,i+1) = H(p,m,n,i)+2*Dt*(...
                1/Dx*h(1)*(Ta(1)-T(p,m,n,i))...
                -1/Dx^2*K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
                +1/Dy*h(4)*(Ta(4)-T(p,m,n,i))...
                -1/Dy^2*K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
                +1/Dz*h(6)*(Ta(6)-T(p,m,n,i))...
                -1/Dz^2*K(T(p,m,n,i),T(p,m,n-1,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
                +Q(p,m,n)/2);
        end
    end
end
%(6)
for p=P+1
    for m=M+1
        for n=N+1
            H(p,m,n,i+1) = H(p,m,n,i)+2*Dt*(...
                1/Dx*h(2)*(Ta(2)-T(p,m,n,i))...
                -1/Dx^2*K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
                +1/Dy*h(4)*(Ta(4)-T(p,m,n,i))...
                -1/Dy^2*K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
                +1/Dz*h(6)*(Ta(6)-T(p,m,n,i))...
                -1/Dz^2*K(T(p,m,n,i),T(p,m,n-1,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
                +Q(p,m,n)/2);
        end
    end
end
%(7)
for p=P+1
    for m=1
        for n=N+1
            H(p,m,n,i+1) = H(p,m,n,i)+2*Dt*(...
                1/Dx*h(2)*(Ta(2)-T(p,m,n,i))...
                -1/Dx^2*K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
                +1/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                -1/Dy^2*K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
                +1/Dz*h(6)*(Ta(6)-T(p,m,n,i))...
                -1/Dz^2*K(T(p,m,n,i),T(p,m,n-1,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
                +Q(p,m,n)/2);
        end
    end
end
%(8)
for p=1
    for m=1
        for n=N+1
            H(p,m,n,i+1) = H(p,m,n,i)+2*Dt*(...
                1/Dx*h(1)*(Ta(1)-T(p,m,n,i))...
                -1/Dx^2*K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
                +1/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                -1/Dy^2*K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
                +1/Dz*h(6)*(Ta(6)-T(p,m,n,i))...
                -1/Dz^2*K(T(p,m,n,i),T(p,m,n-1,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
                +Q(p,m,n)/2);
        end
    end
end

%calculation of nodes on 6 faces
%for face X=0 (left)
for p=1
    for m=2:M
       for n=2:N
           H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
               2/Dx*h(1)*(Ta(1)-T(p,m,n,i))...
               -2/Dx^2*K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i))...
               +1/Dy^2*(K(T(p,m+1,n,i),T(p,m,n,i))*(T(p,m+1,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i)))...
               +1/Dz^2*(K(T(p,m,n-1,i),T(p,m,n,i))*(T(p,m,n-1,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i)))...
               +Q(p,m,n));
        end
    end
 end
%for face X=Lx(right)
for p=P+1
    for m=2:M
        for n=2:N
            H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
                2/Dx*h(2)*(Ta(2)-T(p,m,n,i))...
                -2/Dx^2*K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i))...
                +1/Dy^2*(K(T(p,m+1,n,i),T(p,m,n,i))*(T(p,m+1,n,i)-T(p,m,n,i))...
                     -K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i)))...
                +1/Dz^2*(K(T(p,m,n-1,i),T(p,m,n,i))*(T(p,m,n-1,i)-T(p,m,n,i))...
                     -K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i)))...
                +Q(p,m,n));
        end
    end
end
%for face Y=0 (bottom)
for p=2:P
    for m=1
        for n=2:N
             H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
                 2/Dy*h(3)*(Ta(3)-T(p,m,n,i))...
                 -2/Dy^2*K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i))...
                 +1/Dx^2*(K(T(p+1,m,n,i),T(p,m,n,i))*(T(p+1,m,n,i)-T(p,m,n,i))...
                     -K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i)))...
                 +1/Dz^2*(K(T(p,m,n+1,i),T(p,m,n,i))*(T(p,m,n+1,i)-T(p,m,n,i))...
                     -K(T(p,m,n,i),T(p,m,n-1,i))*(T(p,m,n,i)-T(p,m,n-1,i)))...
                 +Q(p,m,n));
        end
    end
end
%for face Y=My (roof)
for p=2:P
    for m=M+1
        for n=2:N
             H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
                 2/Dy*h(4)*(Ta(4)-T(p,m,n,i))...
                 -2/Dy^2*K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i))...
                 +1/Dx^2*(K(T(p+1,m,n,i),T(p,m,n,i))*(T(p+1,m,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i)))...
                 +1/Dz^2*(K(T(p,m,n+1,i),T(p,m,n,i))*(T(p,m,n+1,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m,n-1,i))*(T(p,m,n,i)-T(p,m,n-1,i)))...
                 +Q(p,m,n));
        end
    end
end
%for face Z=0 (front)
for p=2:P
    for m=2:M
        for n=1
             H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
                 2/Dz*h(5)*(Ta(5)-T(p,m,n,i))...
                 -2/Dz^2*K(T(p,m,n,i),T(p,m,n+1,i))*(T(p,m,n,i)-T(p,m,n+1,i))...
                 +1/Dx^2*(K(T(p-1,m,n,i),T(p,m,n,i))*(T(p-1,m,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p+1,m,n,i))*(T(p,m,n,i)-T(p+1,m,n,i)))...
                 +1/Dy^2*(K(T(p,m-1,n,i),T(p,m,n,i))*(T(p,m-1,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m+1,n,i))*(T(p,m,n,i)-T(p,m+1,n,i)))...
                 +Q(p,m,n));
         end
     end
 end
 %for face Z=Nz (back)
 for p=2:P
     for m=2:M
         for n=N+1
             H(p,m,n,i+1)=H(p,m,n,i)+Dt*(...
                 2/Dz*h(6)*(Ta(6)-T(p,m,n,i))...
                 -2/Dz^2*K(T(p,m,n,i),T(p,m,n-1,i))*(T(p,m,n,i)-T(p,m,n-1,i))...
                 +1/Dx^2*(K(T(p+1,m,n,i),T(p,m,n,i))*(T(p+1,m,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p-1,m,n,i))*(T(p,m,n,i)-T(p-1,m,n,i)))...
                 +1/Dy^2*(K(T(p,m+1,n,i),T(p,m,n,i))*(T(p,m+1,n,i)-T(p,m,n,i))...
                    -K(T(p,m,n,i),T(p,m-1,n,i))*(T(p,m,n,i)-T(p,m-1,n,i)))...
                 +Q(p,m,n));
         end
     end
 end
T(:,:,:,i)=H(:,:,:,i+1)/C;
 %for p=1:P+1
%         for m=1:M+1
       %  for n=1:N+1
        %         T(p,m,n,i)=htooT(H(p,m,n,i+1));
        %  end
      %end
  %end

 
if telapes >=tprint
   b=b+1;
   Tstore(:,:,:,b)= T(:,:,:,i);
   %Hstore(:,:,:,b)=H(:,:,:,i+1);
   t(b)=time;
   telapes =0;
end

H(:,:,:,i)=H(:,:,:,i+1);

time
end
toc
clock
